/*
** joysticks.acepansion public API
*/

#ifndef ACEPANSION_H
#define ACEPANSION_H

#include <exec/types.h>
#include <exec/semaphores.h>


#define LIBNAME "joysticks.acepansion"
#define VERSION 3
#define REVISION 1
#define DATE "12.09.2020"
#define COPYRIGHT " 2016-2020 Philippe Rimauro"

#define API_VERSION 5


BOOL InitResources(VOID);
VOID FreeResources(VOID);


struct ACEpansionPlugin * CreatePlugin(CONST_STRPTR *toolTypes, struct SignalSemaphore *sema);
VOID DeletePlugin(struct ACEpansionPlugin *plugin);
BOOL ActivatePlugin(struct ACEpansionPlugin *plugin, BOOL status);
STRPTR * GetPrefsPlugin(struct ACEpansionPlugin *plugin, APTR pool);

VOID Reset(struct ACEpansionPlugin *plugin);
VOID Emulate(struct ACEpansionPlugin *plugin, ULONG *signals);

VOID WriteIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE value);
VOID ReadIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE * value);
VOID GetAudio(struct ACEpansionPlugin *plugin, SHORT * leftSample, SHORT *rightSample);
VOID Printer(struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy);
VOID Cursor(struct ACEpansionPlugin *plugin);
VOID AcknowledgeInterrupt(struct ACEpansionPlugin *plugin, UBYTE *ivr);
VOID Joystick(struct ACEpansionPlugin *plugin, BOOL com1, BOOL com2, UBYTE *ioData);
VOID ReturnInterrupt(struct ACEpansionPlugin *plugin);
VOID LightDeviceDiodePulse(struct ACEpansionPlugin *plugin);
VOID LightDeviceButton(struct ACEpansionPlugin *plugin, BOOL pressed);

#endif /* ACEPANSION_H */

