#ifndef SUBTASKS_H_
#define SUBTASKS_H_

/* /// "Includes" */

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif
#ifndef EXEC_TASKS_H
#include <exec/tasks.h>
#endif
#ifndef EXEC_PORTS_H
#include <exec/ports.h>
#endif

/* /// */

/* /// "Defines & Macros" */

#define STC_STARTUP  -2
#define STC_SHUTDOWN -1

/* /// */

/* /// "Structures" */

struct SubTaskMsg
{
	struct Message stm_Message;
	WORD           stm_Command;
	IPTR           stm_Parameter;
	LONG           stm_Result;
};

struct SubTask
{
    struct Task      *st_Task;    // sub task pointer
	struct MsgPort   *st_Port;    // allocated by sub task
	struct MsgPort   *st_Reply;   // allocated by main task
	APTR              st_Data;    // more initial data to pass to the sub task
	struct SubTaskMsg st_Message; // Message buffer
};

/* /// */

/* /// "Functions prototypes" */

LONG SendSubTaskMsg(struct SubTask *st, WORD command, IPTR params);
struct SubTask * SpawnSubTask(CONST_STRPTR name, VOID (*func)(VOID), APTR data);
VOID KillSubTask(struct SubTask *st);
VOID ExitSubTask(struct SubTask *st, struct SubTaskMsg *stm);
struct SubTask * InitSubTask(void);

/* /// */

#endif
