/*
 * Haiku wrapper for ACE plugins.
 * Copyright (C) 2020 PulkoMandy <pulkomandy@pulkomandy.tk>
 *
 * Distributed under terms of the MIT license.
 */

#include <arpa/inet.h>

#include <Catalog.h>
#include <LocaleRoster.h>

#include <exec/types.h>

#define CATCOMP_BLOCK
#include "generated/locale_strings.h"

extern "C" STRPTR GetString(struct MyLibBase *base, LONG id)
{
    LONG   *l;
    UWORD  *w;
    STRPTR  builtin;

    static BCatalog* catalog = BLocaleRoster::Default()->GetCatalog();
    if (catalog) {
        char* tmp = (STRPTR)catalog->GetString(id);
        if (tmp && tmp[0])
            return tmp;
    }

	l = (LONG *)CatCompBlock;

    while(*l != (LONG)htonl(id) )
    {
        w = (UWORD *)((ULONG)l + 4);
        l = (LONG *)((ULONG)l + (ULONG)ntohs(*w) + 6);
    }
    builtin = (STRPTR)((ULONG)l + 6);

    return builtin;
}

